using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace ObserverPattern_Parkeringshus
{
    public partial class FormPHus : Form
    {
        P_Hus_Monitor phus = new P_Hus_Monitor(5);
        Queue<Udkrsel> udkrsler = new Queue<Udkrsel>();
        Queue<Indkrsel> indkrsler = new Queue<Indkrsel>();
        public FormPHus()
        {
            InitializeComponent();
        }

        private void btnStartIndkrsel_Click(object sender, EventArgs e)
        {
            Indkrsel nyIndkrsel = new Indkrsel(phus);
            indkrsler.Enqueue(nyIndkrsel);                    // indst i ken
            Thread t = new Thread(nyIndkrsel.Run);
            t.IsBackground = true;                              // baggrundstrd s kun GUI krer som forgrund
            t.Start();
            btnStopIndkrsel.Enabled = true;
        }

        private void btnStartUdkrsel_Click(object sender, EventArgs e)
        {
            Udkrsel nyUdkrsel = new Udkrsel(phus);
            udkrsler.Enqueue(nyUdkrsel);                      // indst i ken
            Thread t = new Thread(nyUdkrsel.Run);
            t.IsBackground = true;                              // baggrundstrd s kun GUI krer som forgrund
            t.Start();
            btnStopUdkrsel.Enabled = true;
        }

        private void btnStopIndkrsel_Click(object sender, EventArgs e)
        {
            Indkrsel stopIndkrsen = indkrsler.Dequeue();
            stopIndkrsen.Stop();
            if (indkrsler.Count == 0)
                btnStopIndkrsel.Enabled = false;
        }

        private void btnStopUdkrsel_Click(object sender, EventArgs e)
        {
            Udkrsel stopUdkrsen = udkrsler.Dequeue();
            stopUdkrsen.Stop();
            if (udkrsler.Count == 0)
                btnStopUdkrsel.Enabled = false;
        }
        private void btnLs_Click(object sender, EventArgs e)
        {
            if (phus.Ls())
            {
                btnLs.Enabled = false;
                btnLsop.Enabled = true;
            }
        }

        private void btnLsop_Click(object sender, EventArgs e)
        {
            phus.LsOp();
            btnLsop.Enabled = false;
            btnLs.Enabled = true;
        }

        private void consoleObserverMetode(string besked, P_Hus_Monitor p_hus)
        {
            Console.WriteLine(besked);
        }

        private void btnStartConsoleObserverAll_Click(object sender, EventArgs e)
        {
            phus.P_Hus_EventAlle += consoleObserverMetode;
        }

        private void btnStopConsoleObserverAll_Click(object sender, EventArgs e)
        {
            phus.P_Hus_EventAlle -= consoleObserverMetode;
        }


        private void btnStartConsoleObserverInd_Click(object sender, EventArgs e)
        {
            phus.P_Hus_EventInd += consoleObserverMetode;
        }

        private void btnStopConsoleObserverInd_Click(object sender, EventArgs e)
        {
            phus.P_Hus_EventInd -= consoleObserverMetode;
        }

        private void btnConsoleObserverFuldTomEventStart_Click(object sender, EventArgs e)
        {
            phus.P_Hus_EventTmt += consoleObserverMetode;
            phus.P_Hus_EventFyldt += consoleObserverMetode;
        }

        private void btnConsoleObserverFuldTomEventSlut_Click(object sender, EventArgs e)
        {
            phus.P_Hus_EventFyldt -= consoleObserverMetode;
            phus.P_Hus_EventTmt -= consoleObserverMetode;
        }

        private void btnNyFormObserver_Click(object sender, EventArgs e)
        {
            FormObserver f = new FormObserver(phus);
            f.Show();
        }


    }
}